#include "mysql_priv.h" //to call THD structure
//#include "./sql/manet/manet_tools.h"
//#include "sql_repl.h"
//#include "repl_failsafe.h"
//#include <m_ctype.h>
//#include <myisam.h>
//#include <my_dir.h>
//#include <time.h>
//#include <stdio.h>
//#include <time.h>

#include "manet_tools.h"
#include <my_global.h>
#include <my_sys.h>
#include <mysql.h>
#include <errmsg.h>
#include <my_getopt.h>
#include <m_string.h>
#include <time.h>
#include <sys/time.h>

//#define mysql_use_result STDCALL mysql_store_result

#include <strings.h>// to use strcasecmp(char * , char * );
#include <ctype.h> // to call isascii

/*
	1) This class should be placed in sql_class.* 
	2) THD should have a pointer to this class
	3) The reference should be renewed everytime a transaction comes.
	
	Class Manet
		methods
			result_order                          //number of statement for current transaction
			is_connected(char * server_ip)
			time_t get_first_deadline()
			time_t get_second_deadline()
			int get_realtime_type()              // use ennumerati
			int get_replication_type()
			I_List<char *> get_list_of_tables() // contains the name of the tables attributes
			I_List<char *> list_participant // IP s participants
			append_order(server_ip,result_order) // should somehow store which result belong to which transaction
*/

//!this is the regular port used by the mysql server
#define MYSQL_PORT 3306




//--------------------------------------------------------------------
//---------- TIME FUNCTIONS COPIED FROM MYSQL CLIENT mysql.cc --------
/*
	ulong timer;
	char timer_buff[32];
	timer = manet_start_timer();
	....operation....
	manet_mysql_end_timer(timer,time_buff);
*/
#if defined( __WIN__) || defined( OS2) || defined(__NETWARE__)
#include <time.h>
#else
#include <sys/times.h>
#ifdef _SC_CLK_TCK				// For mit-pthreads
#undef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC (sysconf(_SC_CLK_TCK))
#endif
#endif

static ulong manet_start_timer(void)
{
#if defined( __WIN__) || defined( OS2) || defined(__NETWARE__)
  return clock();
#else
  struct tms tms_tmp;
  return times(&tms_tmp);
#endif
}

static void manet_nice_time(double sec,char *buff,bool part_second)
{
  ulong tmp;
  if (sec >= 3600.0*24)
  {
    tmp=(ulong) floor(sec/(3600.0*24));
    sec-=3600.0*24*tmp;
    buff=int10_to_str((long) tmp, buff, 10);
    buff=strmov(buff,tmp > 1 ? " days " : " day ");
  }
  if (sec >= 3600.0)
  {
    tmp=(ulong) floor(sec/3600.0);
    sec-=3600.0*tmp;
    buff=int10_to_str((long) tmp, buff, 10);
    buff=strmov(buff,tmp > 1 ? " hours " : " hour ");
  }
  if (sec >= 60.0)
  {
    tmp=(ulong) floor(sec/60.0);
    sec-=60.0*tmp;
    buff=int10_to_str((long) tmp, buff, 10);
    buff=strmov(buff," min ");
  }
  if (part_second)
    sprintf(buff,"%.2f sec",sec);
  else
    sprintf(buff,"%d sec",(int) sec);
}


static void manet_end_timer(char * trans_id,ulong start_time,char *buff)
{
	double trans_time = (double) (manet_start_timer() - start_time) / CLOCKS_PER_SEC;
  	manet_nice_time(trans_time,buff,1);
	log_running_time->put_time(trans_id,trans_time);
	//log_running_time->write_log();
}

static void manet_mysql_end_timer(char * trans_id,ulong start_time,char *buff)
{
  buff[0]=' ';
  buff[1]='(';
  manet_end_timer(trans_id,start_time,buff+2);
  strmov(strend(buff),")");
}
  
  

//----------------END TIME FUNCTIONS COPIED FROM MYSQL CLIENT mysql.cc------------


int external_file_test(void){
THD * thd;
return 5;
}

/*!
  Function to parse through the transaction
  to find the type of transactions, the deadlines
  as well as the operations in the transactions.
*/

/*!
	Function to write the complete flow of a transacion in
  a log file named MANET_LOG.txt
*/
void write_log(char *msg)
{
  FILE *fp;
  fp = fopen("MANET_LOG.txt","a");
  fprintf(fp,"%s\n",msg);
  fclose(fp);
}

void write_log(int msg)
{
  FILE *fp;
  fp = fopen("MANET_LOG.txt","a");
  fprintf(fp,"%i\n",msg);
  fclose(fp);
}


void write_log(const char *msg)
{
  FILE *fp;
  fp = fopen("MANET_LOG.txt","a");
  fprintf(fp,"%s\n",msg);
  fclose(fp);
}

void parse_header(THD *thd , char *packet)
{
  int pkt_length;
  char *spec_data;
  int op_count = 0;
  char pack[1000];
  int i,j,k;
  char *data;
  char *Operation;
  char operations[1000];
  struct tm dtime;
  operations[0]='\0';
  pkt_length = strlen(packet);

  strcpy(pack,packet);
  thd->manet_transaction->threadID = (int) pthread_self();
  i=0;

  /*!
  trying to get the type of transaction, soft/firm;
  if the transacion is a firm transaction, extracting
  the deadline, if it is a soft transaction, extracting
  both the deadlines from the transactions.
  */                                           

  if(strstr(pack,"firm")!=NULL)
  {
  thd->manet_transaction->realTimeTransactionType = 1;
	data = strstr(pack,"deadline");
	data = strstr(data,"=");
	i = 0;
	while(data[i+1]!=',')
	{
		spec_data[i] = data[i+1];
		i = i+1;
	}
	spec_data[i]='\0';
	strptime(spec_data , "%x %X" , &dtime);
  thd->manet_transaction->deadline1 = mktime(&dtime);
  }
  else
  {
 	thd->manet_transaction->realTimeTransactionType = 2;
	data = strstr(pack,"deadline1");
  i = 0;
	data = strstr(data,"=");
        while(data[i+1]!=',')
        {
  	      spec_data[i] = data[i+1];
              i++;
        }
	spec_data[i]='\0';
	strptime(spec_data , "%x %X" , &dtime);
       	thd->manet_transaction->deadline1 = mktime(&dtime);
	data = strstr(pack,"deadline2");
        i = 0;
        data = strstr(data,"=");
        while(data[i+1]!=',')
        {
        	spec_data[i] = data[i+1];
                i++;
        }
        spec_data[i]='\0';
	strptime(spec_data , "%x %X" , &dtime);
       	thd->manet_transaction->deadline2 = mktime(&dtime);
  }
 /*!
  Trying to get the operations into the operations char pointer;
  then storing all the operations of the transactions in the thread
  structure.
 */
  data = strstr(data, ",");
  for(i=0;i<strlen(data);i++)
  {
       	data[i] = data[i+1];
  }
  k=0;
  do
  {
  	i = 0;
	while((data[i]!= '+')&&(data[i]!='\0'))
	{
		operations[i] = data[i];
		i++;
	}
	operations[i]='\0';

	strcpy(thd->manet_transaction->Operation_List[k],operations);
  data = strstr(data,"+");
	if(data!=NULL)
	{
		for(i=0;i<strlen(data);i++)
               	{
			data[i] = data[i+1];
               	}
	}
	k++;
  }while(data!=NULL);

  data=strstr(pack,"+");
  if(data!=NULL)	thd->manet_transaction->requestFromClient = 1;
  else			thd->manet_transaction->requestFromClient = 0;
 /*!
 Trying to get the no. of operations in the transacton packet
 */
 data=strstr(pack,"+");
 if(data!=NULL)
 {
 	for(i=0;i<strlen(data);i++)
	{
		data[i] = data[i+1];
	}
	op_count++;
	while(data!=NULL)
	{
		for(i=0;i<strlen(data);i++)
		{
			data[i] = data[i+1];
		}
		data = strstr(data,"+");
		if(data!=NULL)
		op_count++;
	}
	}
  /*!Getting the source of the transaction,
  that is, getting whether the transaction was sent
  by a client or the coordinating server; then
  setting the number of commits recieved in the transaction.
  */
  if (strstr(pack , "+") == NULL)
  {
  	thd->manet_transaction->requestFromClient = 0;
	if (strstr(pack, "commit") != NULL)
        {
	  if (strstr(thd->manet_transaction->commitCount, "First") == NULL)   strcpy(thd->manet_transaction->commitCount, "First");
          else  strcpy(thd->manet_transaction->commitCount, "Second");
	}
  }

  /*!
  Finding if the transaction is an MRV, MRVP or an OD transaction.
  */
  if (strstr(pack , "&mrvp") != NULL)      thd->manet_transaction->readTransactionType = 2;
  else if (strstr(pack , "&od") != NULL)   thd->manet_transaction->readTransactionType = 3;
  else if (strstr(pack, "&mrv") != NULL)   thd->manet_transaction->readTransactionType = 1;
  else thd->manet_transaction->readTransactionType = 0;
}


char* check_global_schema(char *tables)
{
  char data[50];
  char dataItem[50],Server1[25],Server2[25];
  strcpy(data,tables);
  //write_log("Checking global schema");
  FILE *fp;
  fp = fopen("/usr/local/mysql/bin/manet_config/GlobalSchema.txt","r");
  
  while ((!feof(fp)))
  {
   fscanf(fp , "%s %s %s" , dataItem , Server1 , Server2);
   strcat(dataItem," ");
   /*write_log(dataItem);
   write_log(Server1);
   write_log(Server2);
   */   
   if(!strcmp(dataItem,data))
   {
     //write_log("Data Item matched");
     if(!strcmp(Server1,"localhost") || !strcmp(Server2,"localhost"))  return("localhost");
     //else { write_log(Server1); return(Server1);}
     break;
   }
  }
  return("localhost");
}
/*!
   Function to check the global schema present in the server
   and to return the location of a data item that is required
   by a particular query.
*/
/*char* check_global_schema(THD* thd, char* packet)
{
   char dataItem[50], primaryCopyServer[25], tableName[50], dataItemWithTableName[100];
   char replicaServers[1000], operationType[20];

   FILE *fp;

   if ((strstr(packet, "select") == NULL) && (strstr(packet, "update") == NULL))
   {
   	return NULL;
   }
   fp = fopen("/usr/local/mysql/bin/manet_config/GlobalSchema.txt","r");

   while ((!feof(fp)))
   {
   	fscanf(fp , "%s %s %s %s" , dataItemWithTableName , primaryCopyServer , replicaServers , operationType);

	if (strstr(operationType, "ReadOnly") != NULL)		thd->manet_transaction->readWriteDataItem = 0;
	else		thd->manet_transaction->readWriteDataItem = 1;
	if (strstr(operationType, "PeriodicUpdate") != NULL)
	{
		fscanf(fp, "%d", &thd->manet_transaction->periodicDataItemFrequency);
		thd->manet_transaction->readWriteDataItem = 2;
	}
	strcpy(tableName, strtok(dataItemWithTableName, "."));
	strcpy(dataItem, strtok(NULL, "."));

	if ((strstr(packet, tableName) != NULL) && (strstr(packet, dataItem) != NULL))
	{
		return strdup(primaryCopyServer);//strdup added by percy bernedo, otherwise it does not work
	}
    }
}*/

void safe_write_log(char *msg,int lenght){
  FILE *fp;
  char unknown_char[10];
  char *safe_buffer;
  int pointer = 0;
  safe_buffer = (char * ) malloc(sizeof(char)*lenght);
  memcpy(safe_buffer,msg,lenght);
  fp = fopen("MANET_LOG.txt","a");
  while (pointer < lenght){
		if (isascii(safe_buffer[pointer])){
			fputc(safe_buffer[pointer],fp);
		}else{
			sprintf(unknown_char,"[%d]",(int)msg[pointer]);
			fputs(unknown_char,fp);
		}

	pointer++;
	}
	fputc('\n',fp);	
  free(safe_buffer);
  fclose(fp);

}

/*!
  Function to check whether there exists a connection
  from the server to another specified server
*/
MYSQL* check_connection(THD* thd, char* server_ip, bool prepare, char transid[20])
{
	Connection *Conn;

	I_List_iterator<Connection> connection_it(thd->manet_transaction->Connection_List);
	while((Conn = connection_it++))
	{
		if((strcmp(server_ip,Conn->server) == 0) && (Conn->closed != 1) && (!(Conn->prepared)))
		{
			Conn->prepared = prepare;
			sprintf(Conn->transid, "%s",transid);
	     		return Conn->sockid;
			break;
		}
	}
	return NULL;
}
MYSQL* check_connection(THD* thd, char* server_ip) {
	return check_connection(thd, server_ip, false, "");
}

int send_deadlines(THD *thd , MYSQL *mysql)
{
  MYSQL_RES *result;

  if(OPTION_BEGIN)
  {
    if(mysql_real_query(mysql,"begin",strlen("begin")))
    {
     //write_log("Unable to send begin");
     return -1;
    }
  }
  if(thd->manet_transaction->deadlines != NULL)
  {
    //write_log(thd->manet_transaction->deadlines);
    if(mysql_real_query(mysql,thd->manet_transaction->deadlines,strlen(thd->manet_transaction->deadlines)))
    {
      //write_log("Unable to send deadlines");
      return -1;
    }
    result = mysql_use_result(mysql);
    mysql_free_result(result);                                                 
  }
  return 0;
}

/*!
   Function to connect to a particular server. This function
   also adds the server to the list of connected servers in the
   thread structure.
*/

MYSQL* connect_to_participant(THD *thd, char* server_ip, char *uid, char *pwd, char *db, bool prepare, char transid[20])
{
  Connection *temp = new Connection();

  temp->sockid = mysql_init(NULL);

  if((temp->sockid = mysql_real_connect(temp->sockid, server_ip, uid , pwd, thd->db, 3306, NULL, CLIENT_MULTI_STATEMENTS))==NULL)
  { // Connection failed
	return NULL;
  }
  else
  {  // Connection worked
      sprintf(temp->server , "%s" , server_ip);
      temp->closed = 0;
      temp->prepared = prepare;

      sprintf(temp->transid, "%s", transid);
      thd->manet_transaction->Connection_List.append(temp);    
  }

  return temp->sockid;
}

MYSQL* connect_to_participant(THD *thd, char* server_ip, char *uid, char *pwd, char *db) {
	return connect_to_participant(thd, server_ip, uid, pwd, db, false, "");
}

/*!
  Function to send a particular query to a specified query.
  The function first checks to see if a begin for the transaction
  has already been sent to the server. If not, it sends a begin
  to the server before sending the query to the server. Once a begin has
  been sent for the transaction to server, the begin sent of the Connection
  object for the destination server is changed to 1 to reflect the fact that
  a begin has been sent to the server for this transaction.
*/

int send_query_to_participant(MYSQL *mysql, char *query)
{                                                
	return mysql_real_query(mysql, query,strlen(query));
}

int drop(THD *thd,char *tab_name)
{
  MYSQL *mysql_local;
  char query[256];
  int res;

  sprintf(query,"DROP TABLE IF EXISTS %s;",tab_name);

  if((mysql_local = check_connection(thd , "localhost")) == NULL)
  {
     mysql_local = connect_to_participant(thd,"localhost","root","14momdad",thd->db);
  }

  if (res = mysql_query(mysql_local, query))
  {
    return -1;
  }
  else
  {
    return 0;
  }
}

int store_result(THD *thd,MYSQL *mysql,char *tab_name)
{
  MYSQL_RES *result;
  MYSQL_FIELD *field;                                                      
  MYSQL_ROW row;
  char query[50000];
  memset(query,'\0',50000);
  
  char insert_query[4096];
  memset(insert_query,'\0',4096);
  int i;
  MYSQL_RES *result_local;
  char query1[10];
  int q_res,q1_res;                            
  int ret_result = 0;
  MYSQL *mysql_local;

  do
  {
    if((result = mysql_use_result(mysql)))
    {
      int field_count = result->field_count;
      int field_type[field_count+1];        //1->Requires '',2->Numeric type
      
      if(drop(thd,tab_name) == -1)  return -1;
      sprintf(query,"create table %s(",tab_name);
      for(i = 0;i<field_count;i++)
      {
        field = mysql_fetch_field(result);
        if(i>0) strcat(query,",");
        strcat(query,field->name);
        strcat(query," ");
        switch(field->type)
        {
          case MYSQL_TYPE_LONG:
          {
            //write_log(field->type);
            strcat(query,"INT(");
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_SHORT:
          {
            strcat(query,"SMALLINT(");
            //write_log(query);
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_INT24:
          {
            strcat(query,"INT(");
            field_type[i] = 2;
            break;
          }
          case FIELD_TYPE_STRING:
          {
            strcat(query,"CHAR(");
            field_type[i] = 1;
            break;
          }
          case MYSQL_TYPE_DECIMAL:
          {
            strcat(query,"DECIMAL(");
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_TINY:
          {
            strcat(query,"TINYINT(");
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_FLOAT:
          {
            strcat(query,"FLOAT(");
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_DOUBLE:
          {
            strcat(query,"DOUBLE(");
            field_type[i] = 2;
            break;
          }
          case MYSQL_TYPE_VAR_STRING:
          {
            strcat(query,"CHAR(");
            field_type[i] = 1;
            break;
          }
          case MYSQL_TYPE_TIMESTAMP:
          {
            strcat(query,"TIMESTAMP(");
            field_type[i] = 1;
            break;
          }
          case MYSQL_TYPE_DATE:
          {
            strcat(query,"DATE(");
            field_type[i] = 1;
            break;
          }
        }
        sprintf(query1,"%d)",field->length);
        strcat(query,query1);
      }
      strcat(query,") TYPE = MEMORY;");      

      if((mysql_local = check_connection(thd , "localhost")) == NULL)
	      mysql_local = connect_to_participant(thd,"localhost","root","14momdad",thd->db, false, "");

      if (q_res = mysql_query(mysql_local, query))
      { // Create table failed
        return -1;
      }

      if(row = mysql_fetch_row(result))
      {
        ret_result = 1;
        do
        {
          sprintf(insert_query,"insert into %s values(",tab_name);
          for(i = 0;i<field_count;i++)
          {
            if(i>0)  strcat(insert_query , ",");
            if(row[i])
            {
              switch(field_type[i])
              {
                case 1:
                {
                  strcat(insert_query,"\"");
                  strcat(insert_query,row[i]);
                  strcat(insert_query,"\"");
                  break;
                }
                case 2:
                {
                  strcat(insert_query,row[i]);
                  break;
                }
              }
            }
            else  strcat(insert_query,"NULL");
          }
          strcat(insert_query,");");

          if((mysql_local = check_connection(thd , "localhost")) == NULL)
	          mysql_local = connect_to_participant(thd,"localhost","root","14momdad",thd->db, false, "");

          if (q1_res = mysql_query(mysql_local, insert_query))
          { // Insert failed
            return -1;
          }
        }while ((row = mysql_fetch_row(result)));
      }
    }
    else
    {
      char *err = strdup(mysql_error(mysql));
      net_send_error(thd, 0 , err);
      free(err);
      return -1;
    }
    mysql_free_result(result);
  }while(!mysql_next_result(mysql));
  return 1;
}

void close_all_connections(THD *thd)
{
   Connection *Conn;

   I_List_iterator<Connection> connection_it(thd->manet_transaction->Connection_List);
   while(Conn = connection_it++){
   	mysql_close(Conn->sockid);
   }

   free_list(&(thd->manet_transaction->Connection_List));
}

int send_commit(THD *thd, char command[8])
{
  Connection *Conn = new Connection();
  char commit_query[200];
  char comm_send[200];
  char buff[100];

  I_List_iterator<Connection> connection_it(thd->manet_transaction->Connection_List);
   while((Conn = connection_it++))
   {
      if((Conn->prepared)) 
      {
	sprintf(commit_query, "XA %s '%s'", command, Conn->transid);
        
	sprintf(buff, "GTP: [%s] %s", Conn->sockid->host, commit_query);
	write_log(buff);
 
	mysql_commit(Conn->sockid);
        mysql_real_query(Conn->sockid,commit_query,strlen(commit_query));
	mysql_commit(Conn->sockid);

	Conn->prepared = false;

        ulong rows = mysql_affected_rows(Conn->sockid);
        ulonglong id = mysql_insert_id(Conn->sockid);
        const char *msg = mysql_info(Conn->sockid);
      }
	printf("Closing socket");
     	printf("%i ...", Conn->sockid);
	mysql_close(Conn->sockid);
	printf("Socket closed.\n\n");
  }

    free_list(&(thd->manet_transaction->Connection_List));

    thd->started = false;
    
    thd->manet_transaction->deadline1 = 0; 
    thd->manet_transaction->deadline2 = 0;
    thd->manet_transaction->realTimeTransactionType = 0;

    if (thd->real_id==rt_token) rt_token=0;
	thd->killed=THD::killed_state(0);

    my_pthread_setprio(thd->real_id,WAIT_PRIOR);
}



int store_desc(THD *thd , MYSQL *mysql , char *tab_name)
{
  char query[4096];
  MYSQL *mysql_local;
  MYSQL_RES *result;
  MYSQL_ROW row;
  int field_count,i,q_res;
  char insert_query[4096];
                                                                                                                                                                                                          
  drop(thd,tab_name);

  if ((mysql_local = check_connection(thd, "localhost")) == NULL)	
  	mysql_local = connect_to_participant(thd,"localhost","root","14momdad",thd->db);

  q_res = mysql_query(mysql_local, query);

  if((result = mysql_use_result(mysql)))
  {
    if(row = mysql_fetch_row(result))
    {
      field_count = result->field_count;
      do
      {
        sprintf(insert_query,"insert into %s values(",tab_name);
        for(i = 0;i<field_count;i++)
        {
          //write_log(row[i]);
          if(i>0)  strcat(insert_query , ",");
          strcat(insert_query , "'");
          strcat(insert_query , row[i]);
          strcat(insert_query , "'");
        }
        strcat(insert_query,");");

	if ((mysql_local = check_connection(thd, "localhost")) == NULL)	
  		mysql_local = connect_to_participant(thd,"localhost","root","14momdad",thd->db);

	q_res = mysql_query(mysql_local, insert_query);
      }while ((row = mysql_fetch_row(result)));
    }
    mysql_free_result(result);
  }
}
/*!
	Given a string (concat_sting) containing several strings separated by (tokens)
	this function will return an array of strings.
	It is important to free the memory of the returned array with free for each string
	and for the arrray of strings:
	after the call:
	return_value = string_to_stringarray("aaa,bb|www;sas",",|;")
	we should do:
	free(return_value[0])...free(return_value[3]);free(return_value);
	finally;
	The end of the returned string array is indicated by a NULL value;
*/
char ** string_to_stringarray(char * concat_string, char * tokens){
	if (concat_string==NULL) return NULL; //nothing to process just return 
	if (strcmp(concat_string,"")==0) return NULL; //nothing to process just return 
	char * buff[255];
	memset(buff,0,255*(sizeof(char *)));
	char * aux_table_name = strtok(concat_string,tokens);
	int pos = 0;
	while (aux_table_name!=NULL){
		buff[pos++]=strdup(aux_table_name);
		aux_table_name = strtok(NULL,tokens);
	}
	char ** stringarray=(char **)calloc(sizeof(char **),pos+1);
	stringarray[pos]=NULL;
	while (pos-->0)stringarray[pos]=buff[pos];
	return stringarray;
}
/*!
	Receives a TABLE_LIST list and takes out the names of the table of that list.
	returns a char array containing the table names separated by spaces.
*/
char * get_table_names(TABLE_LIST * tables){
	if (!tables) return 0; // the list is empty, just return 	
	char table_names_buff[1024];
	int i;//to iterate the fields
	memset(table_names_buff,0,1024);
	TABLE_LIST * table;
	for (table= tables; table; table=table->next_local) {
		strcat(table_names_buff,table->table_name);
		strcat(table_names_buff,"|");
/*		
		//THIS IS COMMENTED BECAUSE EVEN IF IT COMPILES
		//THE DYNAMIC STRUCTURE IS NOT LOADED YET AT THIS POINT....
		for (i=0;i < table->table->fields;i++){
			if (i) strcat(table_names_buff,", ");
			strcat(table_names_buff,table->table->field[i]->field_name);
		}
		strcat(table_names_buff,"] ");
*/		
	}
	return strdup(table_names_buff);
};

/*!
	mktime modifies the actual time, this is function
	copies the time into another structure so we can keep track of 
	the error.
	see also summer_time_error(); set_deadlines();
*/
void copy_tm_struct(struct tm *A, struct tm *B){
  A->tm_year	= B->tm_year; 
  A->tm_mon	= B->tm_mon; 
  A->tm_mday	= B->tm_mday;
  A->tm_hour	= B->tm_hour; 
  A->tm_min	= B->tm_min; 
  A->tm_sec	= B->tm_sec; 
  A->tm_isdst	= B->tm_isdst;
}

/*!
	A is the structure after calling mktime
	B is the copied structure before calling mktime
	see also copy_tm_struct(); set_deadlines();
*/
int summer_time_error(struct tm A, struct tm B){
	int difference =0;
	difference = (A.tm_hour-B.tm_hour)*3600;
	difference += (A.tm_min-B.tm_min)*60;
	difference += (A.tm_sec-B.tm_sec);
	return difference;
}

/*!
	*This function sets the deadlines into the thread class THD
	*it should be call as a SQL statement : 
	*set_deadlines(thd,'2001-11-12 18:31:01','2001-11-12 18:31:05')	
	*the dates are going to be processed with  
	*strptime("2001-11-12 18:31:01", "%Y-%m-%d %H:%M:%S", &tm);
	*@return the type of the transaction hard=1 soft=2 failure=-1
	*@param thd is the current thread in execution
	*@param deadline1 is the first deadline holding the format "%Y-%m-%d %H:%M:%S"
	*@param deadline2 is the second deadline holding the format "%Y-%m-%d %H:%M:%S"
	*@see THD
	*@see Manet
	*@see summer_time_error
	*@see copy_tm_struct
*/
long int set_deadlines(THD * thd, String *deadline1, String *deadline2)
{
	char buff[100];

	if (!strcmp(deadline1->c_ptr_safe(),"now"))
	{	
		printf("Thread committed suicide...\n");
		thd->killed = THD::killed_state(1);
		return 0;
	}

  int time_ok=0;
	struct tm dtime;
	struct tm aux_time;// to keep track of the error inserted by mktime
	//checking how many parameters we have 
	if (
	   	((deadline1 && !deadline2)&&(!deadline1->is_empty()))
		||
	   (
	   	(deadline1 && deadline2)
		&&
		(!deadline1->is_empty() && deadline2->is_empty()))
	   )
	{
		write_log("RTS: Calculating transaction type...firm");
		thd->manet_transaction->realTimeTransactionType=1;
		if (doze) // If we're dozing, we need to stop
		{
			system("killall -SIGHUP cpuspeed");
			write_log("PSA: Firm transaction found. Exiting doze mode now...");
			doze = false;
		}
	}
	else if(
	   	(deadline1 && deadline2)
		&&
		(!deadline1->is_empty() && !deadline2->is_empty())
		)
	       
	{
		write_log("RTS: Calculating transaction type...soft");
		thd->manet_transaction->realTimeTransactionType=2;	
	}
	else {	
		write_log("RTS: Calculating transaction type...error");
		return -1;
	}
	
	strptime(deadline1->c_ptr_safe() , "%Y-%m-%d %H:%M:%S" , &dtime);
	dtime.tm_isdst = 0;
	copy_tm_struct(&aux_time,&dtime);
	
	time_ok=thd->manet_transaction->deadline1 = mktime(&dtime);//mktime may modify dtime during summer!!!!!
	int time_error = summer_time_error(dtime,aux_time);
	thd->manet_transaction->deadline1-=time_error;
	//-----------------this is for considering slack time---------------------------
	double avg_time = log_running_time->get_time(thd->manet_transaction->trans_id);
	thd->manet_transaction->deadline1-=(long int)avg_time;
	//-----------------------end of slack time--------------------------------------
	if (time_ok<0)  return -1; 	  //time is not properly written
	else {
		time_t now = time(NULL);

		sprintf(buff, "RTS: The current time is %s", ctime(&now));
		write_log(buff);

		sprintf(buff, "RTS: Deadline 1 set to %s", ctime(&thd->manet_transaction->deadline1));	
		write_log(buff);
		
	}


	if (thd->manet_transaction->realTimeTransactionType==2){
		struct tm dtime1;

		strptime(deadline2->c_ptr_safe() , "%Y-%m-%d %H:%M:%S" , &dtime1);
		
		//Added by Anita
		dtime1.tm_isdst = 0;
		copy_tm_struct(&aux_time,&dtime1);
		//End
		
		time_ok=thd->manet_transaction->deadline2 = mktime(&dtime1);
		
		//Added by Anita
		time_error = summer_time_error(dtime1,aux_time);
		//End
		
		thd->manet_transaction->deadline2-=time_error;
		//-----------------this is for considering slack time---------------------------
		thd->manet_transaction->deadline2-=(long int)avg_time;
		//-----------------------end of slack time--------------------------------------
		if (time_ok<0) return -1; //time is not properly written
		else {
			sprintf(buff, "RTS: Deadline 2 set to %s", ctime(&thd->manet_transaction->deadline2));	
			write_log(buff);
		}

	}
	return thd->manet_transaction->realTimeTransactionType;	
}

/*!
	returns
	-1 trans1<=trans2 (less important)
	1 trans1>trans2 (more important less deadline)
*/
int compare_transactions_deadlines(THD * trans1, THD * trans2, time_t now){
	if ((trans1->manet_transaction->realTimeTransactionType==1)
		&&
		trans2->manet_transaction->realTimeTransactionType==2){
		return 1;
	}else if ((trans1->manet_transaction->realTimeTransactionType==2)
		&&
		trans2->manet_transaction->realTimeTransactionType==1){
		return -1;
	}else if ((trans1->manet_transaction->realTimeTransactionType==1)
		&&
		trans2->manet_transaction->realTimeTransactionType==1){
		return (trans1->manet_transaction->deadline1<trans2->manet_transaction->deadline1)?1:-1;
	}else if ((trans1->manet_transaction->realTimeTransactionType==2)
		&&
		trans2->manet_transaction->realTimeTransactionType==2){
		double T1_deadline1_diff = difftime(trans1->manet_transaction->deadline1,now);
		double T2_deadline1_diff = difftime(trans2->manet_transaction->deadline1,now);
		if ((T1_deadline1_diff<0)&&(T2_deadline1_diff<0)){
		  //both first deadlines have passed, use second deadline for comparison
		  return (trans1->manet_transaction->deadline2<trans1->manet_transaction->deadline2)?1:-1;	
		}
		else if ((T1_deadline1_diff>0)&&(T2_deadline1_diff<0)){
		  return 1;	
		}
		else {
		  return -1;	
		}
	}
}

void set_power_status(THD* current_thread) {
	char buff[100];

	THD* tmp;
	I_List_iterator<THD> it(threads);

	bool flag = false;

	//write_log("Set_Power_Status called!");

	while ((tmp=it++) && (!flag)){
		if (current_thread->manet_transaction->realTimeTransactionType == 1) {
			flag = true;
		}
	}

	if (flag) // Firm transaction found...
	{
		if (doze) // If we're dozing, we need to stop
		{
			system("killall -SIGHUP cpuspeed");
			write_log("PSA: Firm transaction(s) found. Exiting doze mode now...");
			doze = false;
		}
		else // We aren't dozing...do nothing
		{
			//write_log("Form transaction(s) found. Not in sleep mode...");
		}
		
	}
	else // No firm transactions found
	{
		if (doze) // If we're dozing, we do nothing
		{
			//write_log("No firm transactions in system. Currently in sleep mode...");
		}
		else // We're not dozing, so we need to doze
		{	
			doze = true;
			system("killall -SIGUSR2 cpuspeed");
			write_log("PSA: No firm transactions in system. Entering doze mode now...");
		}
	}


}


/*!
Iterates through thread List and sets the least slack time thread priority to
QUERY_PRIOR.
rt_token is a global variable an it is used so that only one thread at a time has the
highest priority. 
it also sets the start_trans_time and end_trans_time
This function only takes into account threads with the OPTION_BEGIN option set, this means that the thread
is processing a transaction.
this parameter is already set by mysql code in 
SQLCOM_BEGIN and SQLCOM_COMMIT
*/
pthread_t realtime_scheduler_setprio(THD * current_thread, char * query){
  THD *tmp;//used to iterate threads list
  int is_empty=1; // the list (threads) is empty (SHOULD NEVER HAPPEN!!)
  char buff[1024+strlen(query)]; // just to print some debug information 

  pthread_t highest_priority_thread = 0;
  int is_begin=0;
  time_t final_deadline = (current_thread->manet_transaction->realTimeTransactionType==1)?
  				(current_thread->manet_transaction->deadline1):
				(current_thread->manet_transaction->realTimeTransactionType==2)?
				(current_thread->manet_transaction->deadline2):0;
  time_t now = time(NULL);
		sprintf(buff,
"REALTIME: RT Transaction (%li) operation (%s) with deadline %li(ms) inside RT_SCHEDULER at %li(ms)",
		current_thread->real_id,query,final_deadline,
		now);
		//write_log(buff);  
	if (strcasecmp("begin",query)==0){
		current_thread->manet_transaction->start_trans_time=now;
		current_thread->manet_transaction->begin_time = manet_start_timer();
		is_begin=1;
	}
  	if (!((current_thread->options & OPTION_BEGIN) || is_begin)) return 0;

  	//We only set priorities to transactions
  	//POST we have a 'begin' statement already
  	if (current_thread->real_id==rt_token){
		sprintf(buff,
		"REALTIME: RT Transaction (%li) operation (%s) about to do nothing, already max prior.",
		current_thread->real_id,query,final_deadline);
		//write_log(buff);  	
	}
	else{//begin ELSE current_thread->real_id!=rt_token
		if (current_thread->manet_transaction->deadline1==0){
		//no deadline yet, do nothing
		sprintf(buff,
		"REALTIME: RT Transaction (%li) operation (%s) about to do nothing , no deadline",
		current_thread->real_id,query,final_deadline);
		//write_log(buff);  	
	
		return 0;
	}

	double current_difference = difftime(current_thread->manet_transaction->deadline1,now);
	double current_difference2 = difftime(current_thread->manet_transaction->deadline2,now);
	
	//sprintf(buff, "BEFORE\nDIFF1 = %d\nDIFF2 = %d\n\n", current_difference, current_difference2);
	//write_log(buff);

	bool good_time = ((

			(current_difference2 <= 0.0)
			&&
			(current_thread->manet_transaction->realTimeTransactionType==2)
	    	)
	   ||
		(
			(current_difference <= 0.0)
			&&
			(current_thread->manet_transaction->realTimeTransactionType==1)
		)
		
	    );

	//sprintf(buff, "Good_time = %i\n", good_time);
	//write_log(buff);

	if (good_time)
	   {
			//sprintf(buff, "AFTER\nDIFF1 = %d\nDIFF2 = %d\n\n", current_difference, current_difference2);
			//write_log(buff);


	   	time_t final_deadline = ((current_thread->manet_transaction->realTimeTransactionType==1)?
			current_thread->manet_transaction->deadline1:
			((current_thread->manet_transaction->realTimeTransactionType==2)?
			current_thread->manet_transaction->deadline2:-1));
		double avg_time = log_running_time->get_time(current_thread->manet_transaction->trans_id);
		sprintf(buff,
		"REALTIME: RT Transaction (%li), Tid (%s),\n \
		with deadline %li(s) aborted at %li(s), avg_time %5.2f(s)\n  \
		error %li(s)",
		current_thread->real_id,
		current_thread->manet_transaction->trans_id,
		final_deadline,
		now,avg_time,(final_deadline-now));

		current_thread->manet_transaction->deadline1=0;
		current_thread->manet_transaction->deadline2=0;
		rt_token = 0;
		current_thread->killed=THD::killed_state(1);
		//write_log(buff);

		
		net_send_error(current_thread,0,buff); //J-REMOVE_DEBUG
		return 0;
	}
		sprintf(buff,
		"REALTIME: RT Transaction (%li) operation (%s) after comparison",
		current_thread->real_id,query,final_deadline);
		//write_log(buff);
	
	//double smallest_time_difference = current_difference;
	highest_priority_thread = current_thread->real_id;
	THD * highest_priority = current_thread;
	VOID(pthread_mutex_lock(&LOCK_thread_count)); 
	//write_log("inside the mutex LOCK_thread_count");
		I_List_iterator<THD> it(threads);
		if (tmp=it++){// threads is not empty
			is_empty=0;
			do
			{
			// only consider threads in the middle of a transaction
			if (!(tmp->options&OPTION_BEGIN)) 		continue;
			// do not consider threads without deadlines
			if (!(tmp->manet_transaction->deadline1<=0)) 	continue;
			// do not compare current thread with himself
			if (current_thread->real_id==tmp->real_id) 	continue;
			// this thread has run out of time, we will not do anything now
			// when the thread is schedulled it will die
			//continue;
				if (compare_transactions_deadlines(highest_priority,tmp,now)<0)
				{
					highest_priority_thread = tmp->real_id;
					highest_priority==tmp;
				}
			}while (tmp=it++);
		}else{
			is_empty=1;//just to make the code readable
			return 0;
		}
	VOID(pthread_mutex_unlock(&LOCK_thread_count));
	//POST: for all thd in threads| highest_priority_thread has the least slack time
	
	VOID(pthread_mutex_lock(&MANET_LOCK_rt_token));
		if (highest_priority_thread!=rt_token){ 
			//if there was something in rt_token, decrease its priority
			if (rt_token){
			my_pthread_setprio(rt_token,WAIT_PRIOR);
			}
			sprintf(buff,"increasing %ld.priority to QUERY_PRIOR",highest_priority_thread);
			my_pthread_setprio(highest_priority_thread,QUERY_PRIOR);
			rt_token = highest_priority_thread;
		} 
	VOID(pthread_mutex_unlock(&MANET_LOCK_rt_token));  	
	}//end ELSE current_thread->real_id!=rt_token
	
	if ((strcasecmp("commit",query)==0)||(strcasecmp("rollback",query)==0)){
		current_thread->manet_transaction->end_trans_time=now;
		double time_difference = 
		difftime(
		current_thread->manet_transaction->end_trans_time,
		current_thread->manet_transaction->start_trans_time
		);
		//TODO: log time_difference and add an id to the transaction
		//we need a list [(id1,time),(id2,time))]
		sprintf(buff,"AVERAGE %s %d",current_thread->manet_transaction->trans_id,time_difference);
		//write_log(buff);
		char time_buff[32];
		//the following function logs the running time
		manet_mysql_end_timer(
		current_thread->manet_transaction->trans_id,
		current_thread->manet_transaction->begin_time,time_buff);
		sprintf(buff,"AVERAGE-> %s %s",
			current_thread->manet_transaction->trans_id,
			time_buff);
		//write_log(buff);		
	}
  return rt_token;
}

/*!Only the highest priority thread should go back to its normal priority
Other threads can save a system call since they are supose to be already in
WAIT_PRIOR if the thread does not has a deadline set then we don't do anything*/
pthread_t realtime_scheduler_unsetprio(THD* current_thread, char * query){

  if (current_thread->manet_transaction->deadline1==0)return 0;
  char buff[100]; // just to print some debug information 
  VOID(pthread_mutex_lock(&MANET_LOCK_rt_token));
	if (pthread_self()==rt_token){//if current thread has higher priority
			my_pthread_setprio(rt_token,WAIT_PRIOR);
			rt_token = 0;
		if ((strcasecmp("commit",query)==0)||(strcasecmp("rollback",query)==0)){
			//resetting the values of the transaction;
			current_thread->manet_transaction->deadline1=0;
			current_thread->manet_transaction->deadline2=0;
			current_thread->manet_transaction->trans_id[0]=0;
			//changing the priority once the transaction is over.
		}
	} 
  VOID(pthread_mutex_unlock(&MANET_LOCK_rt_token));

  return rt_token;
}

/*!
Given a list of tables the function returns the site where the data is located.
"localhost" means it is located in the current site.

IMPORTANT: is not completed
*/

/*given a user returns its password, since the password is already scrambled we need
to store it somewhere to connect to the participating sites*/
char * get_password(char * user){
	return strdup("14momdad");	
};

/*!
This function accesses the global reference to global_schema (extern global_schema;)
The strucutre of this GLOBAL_SCHEMA is
(GLOBAL_SCHEMA)[server,table,points]-->(GLOBAL_SCHEMA)[NULL,table,points]...-->(GLOBAL_SCHEMA)[NULL,"EOL",0]
	|
	|
(GLOBAL_SCHEMA)[server,table,points]-->(GLOBAL_SCHEMA)[NULL,table,points]......-->(GLOBAL_SCHEMA)[NULL,"EOL",0]	
	.
	.
	.
(GLOBAL_SCHEMA)["EOF",NULL,0]	

point are values like:
 value * 1000 + signum(table_in_sever?).
 example: if value = 0 and table is in the server 
 points = 1000*0 + 1 = 1;
 example: if value = 3 and table is in the server 
 points = 1000*3 + 1 = 3001;
 example: if value = 0 and table is not in the server 
 points = 1000*0 + 0 = 0;
 
 returns:
 a null-terminated list of preferred servers sorted depending on the points each table has.
 But regardless the points it tries to return first the localhost, if local host has 
 all the tables needed for the operation.
*/
char ** check_global_schema_t(TABLE_LIST * tables){
	if (global_schema==NULL) return NULL; //should never happen 
	if (global_schema->get_table_name()==NULL) return NULL; //the file was not found
	
	if (!tables) return 0; // the list is empty, just return 	
	TABLE_LIST * table;
	GLOBAL_SCHEMA * server;
	int server_count = 0;
	int number_of_servers = global_schema->nummber_of_servers();
	//servers_points and servers_names are parallalel arrays
	int * servers_points = (int *)calloc(sizeof(int),number_of_servers);
	char ** servers_names = (char **)calloc(sizeof(char **),number_of_servers);
	char ** sorted_servers_names = (char **)calloc(sizeof(char **),number_of_servers);
	for (server = global_schema,server_count=0;
		strcmp(server->get_server_name(),"EOF");
		server=server->next_server(),server_count++){	
		servers_names[server_count]=server->get_server_name();
		for (table= tables; table; table=table->next_local) {
			servers_points[server_count]+=server->has_table(table->table_name);
		}	
	}
	int number_of_tables = 0;
	for (table= tables; table; table=table->next_local)
	{number_of_tables++;}
	int server_index = 0;
	//trying to return Local host by first
	char chosen_server_str[80];
	for (server_index = 0;server_index <server_count;server_index++){
		if (((servers_points[server_index]%1000)>=number_of_tables)
			&&
		   (!strcmp(servers_names[server_index],
		   	global_schema->get_my_server_name())
			)){
			  free(servers_names);
			  free(servers_points);
			  sorted_servers_names[0]=strdup("localhost");
			  sorted_servers_names[1]=0;
			  return sorted_servers_names;
			 }		
	}
	//post:: at least one table is not in the local host
	
	//sorting the servers
	int at_least_one_server_found = 0;
	int aux_server_count = server_count;
	int chosen_server = 0;
	int continue_sort = 1;
	int sort_index = 0;	
	while((aux_server_count--)&&(continue_sort)){
		for (server_index = 0;server_index < server_count; server_index++){
			if (servers_points[server_index]%1000>=number_of_tables){
				if(servers_points[server_index]>servers_points[chosen_server]){
					chosen_server=server_index;		
				}
			}else{
			servers_points[server_index]=0;// invalidating servers that don't have enouhg tables.	
			}
		}
		//post:: chosen_server is the server with more points with 
		if ((servers_points[chosen_server]%1000)>=number_of_tables){
			at_least_one_server_found++;
			sorted_servers_names[sort_index++]=servers_names[chosen_server];
			servers_points[chosen_server]=0;//ensuring it will not be the chosen one in the next loop
		}
		else{		
			//the last chosen server was not a good one all server that 
			//might follow are worst so we end the search here.
			sorted_servers_names[sort_index]=0;
			continue_sort=0;
		}
	}
	free(servers_names);
	free(servers_points);
	if (at_least_one_server_found){
		return sorted_servers_names;
	}
	else{
	//post:: it is nowhere trying localhost
		sorted_servers_names[0]=strdup("localhost");
		sorted_servers_names[1]=0;
		return sorted_servers_names;
	}
}


int compute_timeleft(THD * thd, time_t deadline){
	
	if (!(thd->started)) {
		return 1;
	}

	if (deadline==-1) 
		return 0;  

	time_t now = time (NULL);	

	double slacktime = difftime(deadline, now);	

	if (slacktime > 0) 
		return 1;
	else
		return 0;
	
}
void kill_thread_with_no_time_left(THD * thd){

	write_log("RTS: Deadline has passed. Killing thread...");
	send_commit(thd, "rollback");
}

/*!
if the operation is remote it returns the socket pointer to the participating site
otherwise it returns NULL,
thd has already called the alloc_query function hence the field "query" is loaded and
is the query that will be sent to the participating site if there is one.
after this function you can use the socket to get the results and you should also close
the connection if needed.
*/

MYSQL*  send_query(THD * thd)
{
	char buff[100];

	if (thd->killed) return NULL;
	MYSQL * participating_site_socket;
	LEX	*lex= thd->lex;
	SELECT_LEX *select_lex= &lex->select_lex;
	TABLE_LIST *tables= (TABLE_LIST*) select_lex->table_list.first;
	//-----------------added by percy , just debuggin--
	char * table_names ;
	table_names = get_table_names(tables);
	//char buff[100];
	if (table_names)
	{
		sprintf(buff,"GLOBAL %li.operation using (%s) table(s)",thd->real_id,table_names);
		//write_log(buff);  
		free(table_names);
		participating_site_socket = mysql_init(NULL);
	}
	//-----------------end :just debuggin--
	if (tables)
	{//there are tables, tables is not null
		char ** ar_participating_site_ip = check_global_schema_t(tables);
		int count = 0;
		char aux_buff[100];

		while(ar_participating_site_ip[count] != NULL)  
		{
		sprintf(aux_buff,"POSIBIL: %s",ar_participating_site_ip[count++]);
		//write_log(aux_buff);
		}
		count = 0;
		int enough_time_left = 1;		

		char * participating_site_ip = ar_participating_site_ip[count];
		
		while (enough_time_left){
		while(/*(participating_site_socket == NULL) && */(ar_participating_site_ip[count] != NULL))
		{
			if (thd->manet_transaction->realTimeTransactionType==1) {
				enough_time_left = compute_timeleft(thd, thd->manet_transaction->deadline1);
			}
			else if (thd->manet_transaction->realTimeTransactionType==2) {
				enough_time_left = compute_timeleft(thd, thd->manet_transaction->deadline2);
			}
		
			if (enough_time_left==0){
				char buff[100];
					
				sprintf(buff, "GTP [%s]: Deadline has expired.", participating_site_ip);
				write_log(buff);
				sprintf(buff, "GTP [%s]: Rolling back all prepared transactions.", participating_site_ip);				
				write_log(buff);

				net_send_error(thd, 0,buff); //J-REMOVE_DEBUG

				kill_thread_with_no_time_left(thd);
				return NULL;				
			}

			participating_site_ip = ar_participating_site_ip[count++];
			if (/*strcmp(participating_site_ip,"localhost") &&*/ strcmp(participating_site_ip,"not found"))
			{// is not localhost
				MYSQL_RES *result;
				MYSQL_ROW row;

				bool prepare = preparable(thd->lex->sql_command, thd->started);

				char temp_transid[20];
				sprintf(temp_transid, "None");

				char buff[100];

				if (prepare) {
					sprintf(temp_transid, "trans-%s-%i", global_schema->get_my_server_name(), thd->transid);		
					thd->transid++;
				}

				sprintf(buff,"GLOBAL transaction (%li) from %s in database %s", thd->real_id, participating_site_ip,thd->db); // J-DEBUG
				//write_log(buff); 

				if( (participating_site_socket = check_connection(thd , participating_site_ip, prepare, temp_transid)) == NULL)
				{
					participating_site_socket = connect_to_participant(thd , participating_site_ip , global_schema->get_my_uid(), global_schema->get_my_pwd(),thd->db, prepare, temp_transid);
					// J-DEBUG
					if(participating_site_socket != NULL)
					{
						int result = send_deadlines(thd , participating_site_socket);
					}
				}
				if (participating_site_socket != NULL) 
				{
					char conn_buff[100];
					char  querybuff[255+strlen(thd->query)];
					int x;

					if (strcmp(participating_site_ip, "localhost") != 0) {
						sprintf(buff, "GTP: Starting a global transaction with server %s", participating_site_ip);
						write_log(buff);
					}

					if (prepare) {

						sprintf(querybuff,"XA START '%s'", temp_transid);
						mysql_commit(participating_site_socket);
						x = mysql_real_query(participating_site_socket, querybuff, strlen(querybuff));

						sprintf(buff, "GTP: [%s] %s", participating_site_ip, querybuff);
						write_log(buff);
						if (x > 0) {
							write_log(mysql_error(participating_site_socket));
							send_commit(thd, "rollback");
							return NULL;
						}

						sprintf(querybuff,"%s",thd->query);
						x = mysql_real_query(participating_site_socket, querybuff, strlen(querybuff));

						sprintf(buff, "GTP: [%s] %s", participating_site_ip, querybuff);
						write_log(buff);

						if (x > 0) {
							write_log(mysql_error(participating_site_socket));
							send_commit(thd, "rollback");
							return NULL;
						}

						sprintf(querybuff,"XA END '%s'",temp_transid);
						x = mysql_real_query(participating_site_socket, querybuff, strlen(querybuff));

						sprintf(buff, "GTP: [%s] %s", participating_site_ip, querybuff);
						write_log(buff);
						if (x > 0) {
							write_log(mysql_error(participating_site_socket));
							send_commit(thd, "rollback");
							return NULL;
						}

						sprintf(querybuff,"XA PREPARE '%s'",temp_transid);

						x = mysql_real_query(participating_site_socket, querybuff, strlen(querybuff));						

						sprintf(buff, "GTP: [%s] %s", participating_site_ip, querybuff);
						write_log(buff);
						if (x > 0) {
							write_log(mysql_error(participating_site_socket));
							send_commit(thd, "rollback");
							return NULL;
						}
					}
					else { // Non-preparable statement
						//write_log("Performing a non-preparable query...");
						if (strcmp(participating_site_ip,"localhost")) {

							sprintf(buff, "GTP: [%s] %s", participating_site_ip, thd->query);
							write_log(buff);

							sprintf(querybuff,"%s",thd->query);	
							
							mysql_real_query(participating_site_socket, querybuff, strlen(querybuff));
						}
						else 
							return NULL;
					}

					return participating_site_socket;			//Got connection to remote host
				}
			}
			else
			{
				if (strcmp(participating_site_ip, "localhost"))
					return NULL;
				else
					return NULL;//do_local_host(thd); // Localhost
			}
		}
	}

		//free(ar_participating_site_ip);			//Unable to connect to remote host
		return NULL;	
	}
	else
	{
		//write_log("No tables uses...");
		return NULL;		//No tables used, so localhost	
	}
}

bool preparable(int input, bool started) {

if ((input == SQLCOM_ALTER_TABLE) ||
    (input == SQLCOM_UPDATE) ||
    (input == SQLCOM_INSERT) || 
    (input == SQLCOM_INSERT_SELECT) ||
    (input == SQLCOM_DELETE))
	return (true && started);
else
	return false;


}
